package kolekce.razeni;

import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;

class KomparatorOsobyPodleVysky implements Comparator<Osoba> {
  @Override
  public int compare(Osoba o1, Osoba o2) {
    int v1 = o1.vyska;
    int v2 = o2.vyska;
    return v1 - v2;
  }
}

class KomparatorOsobyPodleVahy implements Comparator<Osoba> {
  public int compare(Osoba o1, Osoba o2) {
    return (int) (o1.vaha - o2.vaha);
  }
}

class KomparatorOsobyPodlePopisu implements Comparator<Osoba> {
  public int compare(Osoba o1, Osoba o2) {
    String s1 = o1.popis;
    String s2 = o2.popis;
    return s1.compareTo(s2);
  }
}

public class OsobaAbsolutniRazeni {
  static Osoba[] poleOsob;

  static void vypisOsob() {
    for (int i = 0;  i < poleOsob.length;  i++) {
      System.out.println("[" + i + "] " + poleOsob[i].toString());
    }
  }
  
  public static void main(String[] args) {
    poleOsob = new Osoba[4];
    poleOsob[0] = new Osoba(186, 82.5, "muz");
    poleOsob[1] = new Osoba(172, 63.0, "zena");
    poleOsob[2] = new Osoba(105, 26.1, "dite");
    poleOsob[3] = new Osoba(116, 80.5, "obezni trpaslik");

//    System.out.println("Prirozene razeni");
//    Arrays.sort(poleOsob);
//    vypisOsob();

    System.out.println("Absolutni razeni podle vysky");
    Arrays.sort(poleOsob, new KomparatorOsobyPodleVysky());
    vypisOsob();

    System.out.println("Absolutni razeni podle vahy");
    KomparatorOsobyPodleVahy ko = new KomparatorOsobyPodleVahy();
    Arrays.sort(poleOsob, ko);
    vypisOsob();
//
    System.out.println("Absolutni razeni podle popisu");
    Arrays.sort(poleOsob, new KomparatorOsobyPodlePopisu());
    vypisOsob();
//
    System.out.println("Prirozene razeni podle vysky sestupne");
    Arrays.sort(poleOsob, Collections.reverseOrder());
    vypisOsob();
//
    System.out.println("Absolutni razeni podle vysky sestupne");
    Arrays.sort(poleOsob,
                Collections.reverseOrder(new KomparatorOsobyPodleVysky()));
    vypisOsob();
  }
}






