package anonymni;

import java.util.Arrays;
import java.util.Comparator;

class Osoba implements Comparable<Osoba> {
  private int vyska;
  private double vaha;
  private String popis;
  
  Osoba(int vyska, double vaha, String popis) {
    this.vyska = vyska;
    this.vaha = vaha;
    this.popis = popis;
  }
  
  public int compareTo(Osoba os) {
    int osVyska = os.vyska;
    if (this.vyska > osVyska)
      return +1;
    else if (this.vyska == osVyska)
      return 0;
    else
      return -1;
  }
  
  public String toString() {
    return "vy = " + vyska + ", va = " + vaha + ", " +
    popis ;
  }
  
  final public static Comparator<Osoba> KOMPARATOR_PODLE_VAHY = 
    new Comparator<Osoba>() {
      public int compare(Osoba o1, Osoba o2) {
        return (int) (o1.vaha - o2.vaha);
      }
    };

  final public static Comparator<Osoba> KOMPARATOR_PODLE_POPISU = 
    new Comparator<Osoba>() {
      public int compare(Osoba o1, Osoba o2) {
        String s1 = o1.popis;
        String s2 = o2.popis;
        return s1.compareTo(s2);
      }
    };

}

public class Komparatory {
  public static void main(String[] args) {
    Osoba[] poleOsob = new Osoba[4];
    poleOsob[0] = new Osoba(186, 82.5, "muz");
    poleOsob[1] = new Osoba(172, 63.0, "zena");
    poleOsob[2] = new Osoba(105, 26.1, "dite");
    poleOsob[3] = new Osoba(116, 80.5, "obezni trpaslik");

//    Arrays.sort(poleOsob, Osoba.KOMPARATOR_PODLE_VAHY);
    Arrays.sort(poleOsob, Osoba.KOMPARATOR_PODLE_POPISU);

    for (int i = 0;  i < poleOsob.length;  i++)
      System.out.println("[" + i + "] " + poleOsob[i]);
  }

}
