package polymorfismus_3;


import java.util.ArrayList;
import java.util.List;

public final class Hlavni {

  private Hlavni() { /* prazdny konstruktor */ }
  
  public static void main(String[] args) {
    SamoobsluznaRestaurace restaurace = new SamoobsluznaRestaurace();
    
    List<IHosteny> seznamHostu = restaurace.getSeznamHostu();
    seznamHostu.add(new American().objednavaJidlo("steak", 300));
    seznamHostu.add(new Japonec().objednavaJidlo("susi", 200));
    seznamHostu.add(new Ind().objednavaJidlo("capati", 80));
    seznamHostu.add(new Zlatokop().objednavaJidlo("fazole", 50));
    
    List<Pokladni> seznamPokladnich = new ArrayList<>();
    seznamPokladnich.add(new Pokladni());
    seznamPokladnich.add(new Pokladni());
    restaurace.najistAZaplatit(seznamPokladnich);
    
    System.out.println("Celkova utrata: " + restaurace.getZisk());
    for (IHosteny host : seznamHostu) {
      System.out.println(host.zbyvaPenez());
    }
  }
}
