package agregace;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import lambda.Osoba;
import lambda.SeznamOsob;

public class KolekceMapaJmeno {

  public static void main(String[] args) {
    List<Osoba> seznam = SeznamOsob.getSeznam();
    
    Map<Osoba.Pohlavi, List<String>> jmenaPodlePohlavi = seznam
        .stream()
        .collect(
            Collectors.groupingBy(
                Osoba::getPohlavi,                      
                Collectors.mapping(
                    Osoba::getJmeno,
                    Collectors.toList())));
     
    System.out.println("Seznam jmen podle pohlavi = " + jmenaPodlePohlavi);
  }

}
