package lambda;

import java.util.List;

interface IKriterium {
  public boolean vyhovuje(Osoba o);
}

class ZenaVyssiNez160 implements IKriterium {
  @Override
  public boolean vyhovuje(Osoba o) {
    return o.getPohlavi() == Osoba.Pohlavi.ZENA  
           &&  o.getVyska() >= 160;
  }    
}

class MuzNizsiNez170 implements IKriterium {
  @Override
  public boolean vyhovuje(Osoba o) {
    return o.getPohlavi() == Osoba.Pohlavi.MUZ  
           &&  o.getVyska() < 170;
  }    
}

// kriterium v samostatne tride
public class HledaniOsob_2 {
  
  public static void hledani(List<Osoba> seznam, IKriterium kriterium) {
    for (Osoba o : seznam) {
      if (kriterium.vyhovuje(o)) {
        o.vypis();
      }
    }
  }
  
  public static void main(String[] args) {
    List<Osoba> seznam = SeznamOsob.getSeznam();
    hledani(seznam, new ZenaVyssiNez160());
    hledani(seznam, new MuzNizsiNez170());
  }

}





