package lambda;

import java.util.List;
import java.util.function.Consumer;
import java.util.function.Predicate;

// kriterium v lamba vyrazu a 
// standardni genericke funkcni rozhrani pro test i pro akci
public class HledaniOsob_6 {
  
  public static void hledani(List<Osoba> seznam, 
                             Predicate<Osoba> kriterium, 
                             Consumer<Osoba> akce) {
    for (Osoba o : seznam) {
      if (kriterium.test(o)) {
        akce.accept(o);
      }
    }
  }
  
  public static void main(String[] args) {
    List<Osoba> seznam = SeznamOsob.getSeznam();
    hledani(seznam, 
            o -> o.getPohlavi() == Osoba.Pohlavi.ZENA  
                 &&  o.getVyska() >= 160,
//            o -> System.out.println(o)
                 o -> o.vypis()
//                 o -> o.jmena()
           );
  }

}
