package lambda;

import java.util.List;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Predicate;

// kriterium v lamba vyrazu a 
// standardni genericke funkcni rozhrani pro test i pro akci
// plus prubezne ziskani a zpracovani dat 
public class HledaniOsob_7 {
  
  public static void hledani(List<Osoba> seznam, 
                             Predicate<Osoba> kriterium,
                             Function<Osoba, String> mapovani,
                             Consumer<String> akce) {
    for (Osoba o : seznam) {
      if (kriterium.test(o)) {
        String data = mapovani.apply(o);
        akce.accept(data);
      }
    }
  }
  
  public static void main(String[] args) {
    List<Osoba> seznam = SeznamOsob.getSeznam();
    hledani(seznam, 
            o -> o.getPohlavi() == Osoba.Pohlavi.ZENA  
                 &&  o.getVyska() >= 160,
//            o -> o.getJmeno(),
//            o -> o.getVyska(),
            o -> "" + o.getVyska(),
            d -> System.out.println(d)
           );
  }

}







