package lambda;

import java.util.List;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Predicate;

// kriterium v lamba vyrazu a 
// standardni genericke funkcni rozhrani pro test i pro akci
// plus prubezne ziskani a zpracovani dat 
// vse genericke
public class HledaniOsob_8 {
  
  public static <X, Y> void hledani(Iterable<X> seznam, 
                                    Predicate<X> kriterium,
                                    Function<X, Y> mapovani,
                                    Consumer<Y> akce) {
    for (X o : seznam) {
      if (kriterium.test(o)) {
        Y data = mapovani.apply(o);
        akce.accept(data);
      }
    }
  }
  
  public static void main(String[] args) {
    List<Osoba> seznam = SeznamOsob.getSeznam();
    hledani(seznam, 
            o -> o.getPohlavi() == Osoba.Pohlavi.ZENA  
                 &&  o.getVyska() >= 160,
//            o -> o.getJmeno(),
            o -> o.getVyska(),
            data -> System.out.println(data)
           );
  }

}
