package lambda;

import java.util.ArrayList;
import java.util.List;

public class SeznamOsob {
  private static final String[][] OSOBY = {
    {"Anna", "155", "Z"}, {"Jana", "165", "Z"}, {"Hana", "175", "Z"},
    {"Josef", "160", "M"}, {"Karel", "170", "M"}, {"Alois", "180", "M"},
  };
  
  public static List<Osoba> getSeznam() {
    List<Osoba> seznam = new ArrayList<>();
    for (String[] osoba : OSOBY) {
      int vyska = Integer.parseInt(osoba[1]);
      Osoba.Pohlavi pohlavi = osoba[2].startsWith("Z") ? Osoba.Pohlavi.ZENA : Osoba.Pohlavi.MUZ;
      seznam.add(new Osoba(osoba[0], vyska, pohlavi));
    }
    return seznam;
  }
}
