package optional;

import java.util.Optional;
import java.util.OptionalInt;

public class Predmet {
  private final static String NENI_K_DISPOZICI = "N/A";
  
  private String zkratka;
  private Optional<String> nazev;
  private OptionalInt znamka;

  public Predmet() {
    this(null, Optional.empty());
  }

  public Predmet(String zkratka, Optional<String> nazev) {
    this.zkratka = zkratka;
    this.nazev = nazev;
    znamka = OptionalInt.empty();
  }

  public String getZkratka() {
    return zkratka;
  }

  public String getNazev() {
    return nazev.orElse(NENI_K_DISPOZICI);
  }

  public OptionalInt getZnamka() {
    return znamka;
  }

  public void setZnamka(OptionalInt znamka) {
    this.znamka = znamka;
  }

  @Override
  public String toString() {
    return "[zkratka=" + zkratka + ", nazev=" + nazev
           + ", znamka=" + znamka + "]";
  }
  
}
