package optional.lepsi;

import java.util.Optional;
import java.util.OptionalInt;

public class Predmet {
  private final static String NENI_K_DISPOZICI = "N/A";
  private final static int ZNAMKA_NENI_K_DISPOZICI = 0;

  private Optional<String> zkratka;
  private Optional<String> nazev;
  private OptionalInt znamka;

  public Predmet(String zkratka) {
    this(zkratka, "");
  }

  public Predmet(String zkratka, String nazev) {
    this.zkratka = transformString(zkratka);
    this.nazev = transformString(nazev);
    this.znamka = OptionalInt.empty();
  }

  public String getZkratka() {
    return zkratka.orElse(NENI_K_DISPOZICI);
  }

  public String getNazev() {
    return nazev.orElse(NENI_K_DISPOZICI);
  }

  public int getZnamka() {
    return znamka.orElse(ZNAMKA_NENI_K_DISPOZICI);
  }

  public void setNazev(String nazev) {
    this.nazev = transformString(nazev);
  }

  public void setZnamka(int znamka) {
    this.znamka = transformInt(znamka);
  }

  @Override
  public String toString() {
    return "[zkratka=" + getZkratka() + ", nazev=" + getNazev()
           + ", znamka=" + getZnamka() + "]";
  }

  private Optional<String> transformString(String str) {
    Optional<String> oStr = Optional.empty();
    if (str != null) {
      if (str.isBlank() == false) {
        oStr = Optional.of(str.trim());
      }
    }
    return oStr;
  }

  private OptionalInt transformInt(int cislo) {
    OptionalInt oCislo = OptionalInt.empty();
    if (cislo > ZNAMKA_NENI_K_DISPOZICI) {
      oCislo = OptionalInt.of(cislo);
    }
    return oCislo;
  }
}
