package razeni;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

public class RazeniSekvencniParalelniStream {
  
  private static final int MAX = 1_000_000_0;

  public static void main(String[] args) {
    List<Integer> seznam = new ArrayList<>(MAX);
    
    // naplneni 
    for (int i = 1; i <= MAX; i++) {
      seznam.add(Integer.valueOf(i));
    }
    
    if (MAX <= 10) {
      System.out.println(seznam);
    }
    
    Comparator<Integer> vzestupne = Integer::compare;
    Comparator<Integer> reversed = vzestupne.reversed();
    
    long zac = System.nanoTime();
    List<Integer> serazenySeznam = seznam
//       .parallelStream()
       .stream()
       .sorted(reversed)
       .collect(Collectors.toList());
    long kon = System.nanoTime();
    long cas = (kon - zac) / 1000000;
    System.out.println("Cas = " + cas + " [msec]");

    if (MAX <= 10) {
      System.out.println(serazenySeznam);
    }
  }

}
