package anotace;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

import org.junit.Test;

public class JUnitTestySpusteniOsoba {

  private static Method[] serazeniMetodPodlePoradi(Method[] metody) {
    Method[] poradi = new Method[metody.length];
    
    // zarazeni metod s poradi != 0
    int nejvyssiIndex = 0;
    for (Method met : metody) {
      if (met.isAnnotationPresent(PodminkySpusteniTestu.class)) {
        PodminkySpusteniTestu pst = met.getAnnotation(PodminkySpusteniTestu.class);
        int index = pst.poradi() - 1;
        if (index >= 0) {
          poradi[index] = met;
          if (nejvyssiIndex < index) {
            nejvyssiIndex = index;
          }
        }
      }
    }
    
    // zarazeni metod s poradi == 0 za vsechny jiz zarazene
    for (Method met : metody) {
      if (met.isAnnotationPresent(PodminkySpusteniTestu.class)) {
        PodminkySpusteniTestu pst = met.getAnnotation(PodminkySpusteniTestu.class);
        int index = pst.poradi();
        if (index == 0) {
          nejvyssiIndex++;
          poradi[nejvyssiIndex] = met;
        }
      }
    }
    
    return poradi;
  }
  
  private static void spusteniTestu(Method[] metody, MistoSpousteni misto, 
                                    Object instance) {
    System.out.println("Spoustim testy na: " + misto.name());
    int proslo = 0;
    int chybne = 0;
    for (Method met : metody) {
      if (met.isAnnotationPresent(Test.class) == false) {
        continue;
      }
      if (met.isAnnotationPresent(PodminkySpusteniTestu.class) == false) {
        continue;
      }
      PodminkySpusteniTestu pst = met.getAnnotation(PodminkySpusteniTestu.class);
      MistoSpousteni[] ms = pst.misto();
      // pro anotaci misto={MistoSpousteni.DESKTOP, MistoSpousteni.VALIDATOR}
      if (ms[0] == misto || ms[ms.length - 1] == misto) {
        System.out.print(" - Test metody " + met.getName() + "() ");
        try {
          met.invoke(instance);
          System.out.println("OK");
          proslo++;
        } catch (Exception ex) {
          System.out.println("selhal z duvodu\n\t" + ex.getCause());
          chybne++;
        }
      }
    }
    System.out.println("Proslo: " + proslo + ", selhalo: " + chybne);
  }
  
  public static void main(String[] args) throws Exception {
    Class<?> zkoumanaClass = Class.forName("anotace.OsobaTest");
    
    Method[] serazeneMetody = 
        serazeniMetodPodlePoradi(zkoumanaClass.getDeclaredMethods());

    Constructor<?> konstruktor = zkoumanaClass.getDeclaredConstructor();
    Object instance = konstruktor.newInstance();
    spusteniTestu(serazeneMetody, MistoSpousteni.DESKTOP, instance);
    spusteniTestu(serazeneMetody, MistoSpousteni.VALIDATOR, instance);
  }

}
