package reflexe;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

public class AnonymniVolani {

  public static void main(String[] args) throws Exception {
    Class<?> zkoumanaClass = Class.forName("reflexe.UkazkovaTrida");
    Method[] metody = zkoumanaClass.getDeclaredMethods();

    System.out.println("Staticke metody");
    for (Method metoda : metody) {
      int modifikatory = metoda.getModifiers();
      if (Modifier.isStatic(modifikatory) == true) {
        if (metoda.getName().equals("main")) {
          // nechci spoustet main()
          continue;
        }
        System.out.println("Volani metody: " + metoda.getName());
        if (metoda.getParameterTypes().length == 0) {
          // staticka bez parametru
          metoda.invoke(null);
        }
        else {
          // staticka s parametry
          metoda.invoke(null, 2);
        }
      }
    }

    System.out.println("\nInstancni metody");
    Constructor<?> konstruktor = zkoumanaClass.getDeclaredConstructor();
    Object instance = konstruktor.newInstance();
    for (Method metoda : metody) {
      int modifikatory = metoda.getModifiers();
      if (Modifier.isStatic(modifikatory) == false) {
        System.out.println("Volani metody: " + metoda.getName());
        if (metoda.getParameterTypes().length == 0) {
          // instancni bez parametru
          metoda.invoke(instance);
        }
        else {
          // instancni s parametry
          metoda.invoke(instance, 2);
        }
      }
    }
  }

}
