package reflexe;

public class UkazkovaTrida {
  public static final String STATICKA_KONSTANTA = "obsah staticke konstanty";
  private static int statickaPromenna = 3;

  private final double INSTANCNI_KONSTANTA = 3.14;
  private boolean instancniPromenna;
  
  public UkazkovaTrida() {
    this(true);
  }
  
  private UkazkovaTrida(boolean nastaveni) {
    this.instancniPromenna = nastaveni;
  }
  
//  public static void a() {
//    System.out.println("A");
//  }
  
  public static void statickaMetodaBezParametru() {
    System.out.println("STATICKA_KONSTANTA = " + STATICKA_KONSTANTA);
  }
  
  public static int statickaMetodaSParametrem(int nasobek) {
    statickaPromenna = statickaPromenna * nasobek;
    System.out.println("statickaPromenna = " + statickaPromenna);
    return statickaPromenna;
  }

  public boolean instancniMetodaBezParametru() {
    instancniPromenna = instancniPromenna ? false : true;
    System.out.println("instancniPromenna = " + instancniPromenna);
    return instancniPromenna;
  }

  void instancniMetodaSParametrem(int nasobek) {
    System.out.println("INSTANCNI_KONSTANTA = " + INSTANCNI_KONSTANTA * nasobek);
  }

  
  public static void main(String[] args) {
    UkazkovaTrida utFalse = new UkazkovaTrida(false);
    utFalse.instancniMetodaBezParametru();
    utFalse.instancniMetodaSParametrem(1);

    UkazkovaTrida utTrue = new UkazkovaTrida();
    utTrue.instancniMetodaBezParametru();
    
    statickaMetodaBezParametru();
    statickaMetodaSParametrem(1);
  }

}
